program rinc;

{$APPTYPE CONSOLE}

uses
  SysUtils;

function increase(s:string):string;
var w,t:string;
begin
  w:='';
  t:='';
  while not (s[length(s)] in ['0'..'9']) do
  begin
    t:=s[length(s)]+t;
    delete(s,length(s),1);
  end;
  while s[length(s)] in ['0'..'9'] do
  begin
    w:=s[length(s)]+w;
    delete(s,length(s),1);
  end;
  w:=inttostr(strtoint(w)+1);
  if (w='10') and (s[length(s)]=' ') then
    delete(s,length(s),1);
  if (w='100') then
  begin
    if s[length(s)] in ['.',','] then
      s:=increase(s)+' 0'+t
                         else
    begin
      s:=s+' 0'+t;
      writeln('ERROR: version limit 99.99.99.99 reached and passed. current version will be 0.0.0.0!');
    end;
  end        else
    s:=s+w+t;
  result:=s;
end;

var f,t:textfile; s:string;
begin
  if paramcount<>1 then
  begin
    writeln('Syntax: '+paramstr(0)+' <projectName.rc>');
    exit;
  end;
  assignfile(f,paramstr(1));
  assignfile(t,paramstr(1)+'.tmp');
  reset(f);
  rewrite(t);
  while not eof(f) do
  begin
    readln(f,s);
    if pos('FILEVERSION ',s)>0 then
      s:=increase(s)
    else
    if pos('PRODUCTVERSION ',s)>0 then
      s:=increase(s)
    else
    if pos('"FileVersion"',s)>0 then
      s:=increase(s)
    else
    if pos('"ProductVersion"',s)>0 then
      s:=increase(s);
    writeln(t,s);
  end;
  closefile(f);
  closefile(t);
  deletefile(paramstr(1));
  rename(t,paramstr(1));
end.
